package rabinizer.exec;

import java.util.ArrayList;
import java.util.BitSet;

/**
 * Helper class for transferring general acceptance condtions from Rabinizer to
 * Prism (used in a submission to CAV 2013).
 * 
 * @author andreas
 * 
 */
public class GenAccCondPrism {

	class Condition {
		public BitSet finSet;
		public ArrayList<BitSet> infSets;
	}

	private ArrayList<Condition> conds;

	public GenAccCondPrism() {
		conds = new ArrayList<Condition>();
	}

	public void addAccCond(BitSet f, ArrayList<BitSet> infs) {
		Condition c = new Condition();
		c.finSet = f;
		c.infSets = infs;
		conds.add(c);
	}

	public ArrayList<BitSet> getInf(int i) {
		return conds.get(i).infSets;
	}

	public BitSet getFin(int i) {
		return conds.get(i).finSet;
	}

	public int getNrOfAccConds() {
		return conds.size();
	}

}
