package tests;

import static org.junit.Assert.*;

import java.io.StringReader;
import java.util.Arrays;
import java.util.Collection;

import org.junit.Test;

import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

import rabinizer.formulas.Formula;
import rabinizer.parser.LTLParser;

@RunWith(value = Parameterized.class)
public class OperatorPrecedence {

	private String input;
	private String expected;	
	
	public OperatorPrecedence(String input, String expected) {
		this.input = input;
		this.expected = expected;
	}

	@Parameters
	public static Collection<Object[]> data() {
		Object[][] data = new Object[][] { 
				{ "F a U b", "(F a) U b" },
				{ "G a U b", "(G a) U b" },
				{ "X a U b", "(X a) U b" },
				{ "! a U b", "! (a U b)" }, //TODO: pass this test
				{ "! a & b", "(! a) & b" },
				{ "! a | b", "(! a) | b" },				
		};
		return Arrays.asList(data);
	}

	@Test
	public void pushTest() {
		System.out.println(this.getClass().getCanonicalName()+" : "+input+" and "+expected);
		
		LTLParser parser = new LTLParser(new StringReader(input));
		Formula inf = null;
		try { inf = parser.parse(); }
		catch (Exception e) { assertTrue(false); }
		
		parser.ReInit(new StringReader(expected));
		Formula exf = null;
		try{ exf = parser.parsePreviousAtoms(); }
		catch (Exception e) { assertTrue(false); }
		
		assertTrue(inf.equals(exf));
	}

}
