package tests;

import static org.junit.Assert.*;

import java.io.StringReader;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.junit.Test;

import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

import rabinizer.formulas.Formula;
import rabinizer.parser.LTLParser;

@RunWith(value = Parameterized.class)
public class RecurrentFormulas {

	private String input;
	private List<String> expected;	
	
	public RecurrentFormulas(String input, List<String> expected) {
		this.input = input;
		this.expected = expected;
	}

	@Parameters
	public static Collection<Object[]> data() {
		Object[][] data = new Object[][] { 
				{ "true | a & G (a & F b)", Arrays.asList("a & F b", "b") },
				{ "G (F G a | G F b)", Arrays.asList("a", "b") },
				{ "F a", Arrays.asList() },
				{ "G a U X G b", Arrays.asList("a", "b") },
				
				{ "G (F a | F G b)", Arrays.asList("a", "b") },
				{ "G (a | F b)", Arrays.asList("a | F b", "b") },
				{ "G (F a & F b)", Arrays.asList("a", "b") },
				{ "G X (a & F b)", Arrays.asList("X (a & F b)", "b") },
				{ "G (X X a | F b)", Arrays.asList("X X a | F b", "b") },
				
		};
		return Arrays.asList(data);
	}

	@Test
	public void pushTest() {
		System.out.println(this.getClass().getCanonicalName()+" : "+input+" and "+expected);

		LTLParser parser = new LTLParser(new StringReader(input));
		Formula inf = null;
		try { inf = parser.parse(); }
		catch (Exception e) { assertTrue(false); }
		
		Set<Formula> expectedFormulas = new HashSet<Formula>();
		for (String srf : expected) {
			parser.ReInit(new StringReader(srf));
			try { expectedFormulas.add(parser.parsePreviousAtoms()); }
			catch (Exception e) { assertTrue(false); }
		}

		//Set<Formula> recurrentFormulas = inf.recurrentFormulas();
		
		//assertTrue(expectedFormulas.equals(recurrentFormulas));
		assertTrue(false);
	}
}
