package tests;

import static org.junit.Assert.*;

import java.io.StringReader;
import java.util.Arrays;
import java.util.Collection;

import org.junit.Test;

import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

import rabinizer.formulas.Formula;
import rabinizer.parser.LTLParser;

@RunWith(value = Parameterized.class)
public class RemoveX {

	private String input;
	private String expected;	
	
	public RemoveX(String input, String expected) {
		this.input = input;
		this.expected = expected;
	}

    @Parameters
	public static Collection<Object[]> data() {
        Object[][] data = new Object[][] { 
            { "false | a & G (a & F b)", "false | a & G (a & F b)" },
            { "F a | X b", "F a | b" },
            { "G a U X G b", "G a U X G b" },

            { "a & X b", "a & b" },
            { "(a & X b) | (b & X X a)", "(a & b) | (b & X a)" },
            { "X a & G b", "a & G b" },
            { "a & (b | X c)", "a & (b | c)" },
        };
        return Arrays.asList(data);
    }

	@Test
	public void pushTest() {
		System.out.println(this.getClass().getCanonicalName()+" : "+input+" and "+expected);
		
		LTLParser parser = new LTLParser(new StringReader(input));
		Formula inf = null;
		try { inf = parser.parse(); }
		catch (Exception e) { assertTrue(false); }
		
		parser.ReInit(new StringReader(expected));
		Formula exf = null;
		try { exf = parser.parsePreviousAtoms(); }
		catch (Exception e) { assertTrue(false); }
		
		assertTrue(exf.equals(inf.removeX()));
	}
}
